diff --git a/ti-processor-sdk-linux-rt-k2e-evm-03.03.00.04/board-support/linux-rt-4.4.41+gitAUTOINC+968d071ce9-g968d071ce9/arch/arm/boot/dts/keystone-k2e-evm.dts b/ti-processor-sdk-linux-rt-k2e-evm-03.03.00.04/board-support/linux-rt-4.4.41+gitAUTOINC+968d071ce9-g968d071ce9/arch/arm/boot/dts/keystone-k2e-evm.dts
index 44389ac..fb6671a 100644
--- a/ti-processor-sdk-linux-rt-k2e-evm-03.03.00.04/board-support/linux-rt-4.4.41+gitAUTOINC+968d071ce9-g968d071ce9/arch/arm/boot/dts/keystone-k2e-evm.dts
+++ b/ti-processor-sdk-linux-rt-k2e-evm-03.03.00.04/board-support/linux-rt-4.4.41+gitAUTOINC+968d071ce9-g968d071ce9/arch/arm/boot/dts/keystone-k2e-evm.dts
@@ -100,6 +100,37 @@
 		compatible = "at,24c1024";
 		reg = <0x50>;
 	};
+	eeprom@54 {
+		compatible = "at,24c08";
+		reg = <0x54>;
+	};
+};
+
+&i2c1 {
+ 	expander0: pca6416a@20 {	/* boot mode config */
+		compatible = "ti,tca6416";
+ 	        gpio-controller;
+ 	        reg = <0x20>;
+		#gpio-cells = <2>;
+ 	};
+	ucd90160@6b {
+		compatible = "ti,ucd90160";
+		reg = <0x6b>;
+	};
+};
+
+&i2c2 {
+ 	expander1: pca9555@20 {	/* board ID */
+ 	        compatible = "nxp,pca9555";
+ 	        pinctrl-names = "default";
+ 	        gpio-controller;
+ 	        reg = <0x20>;
+ 	};
+
+	sensor0: tmp75@48 {
+		compatible = "tmp75";
+		reg = <0x48>;
+	};
 };
 
 &aemif {
@@ -179,19 +210,55 @@
 &mdio {
 	status = "ok";
 	ethphy0: ethernet-phy@0 {
-		compatible = "marvell,88E1514", "marvell,88E1510", "ethernet-phy-ieee802.3-c22";
-		reg = <0>;
+		compatible = "broadcom,89820", "ethernet-phy-ieee802.3-c22";
+		reg = <1>;
 	};
 
 	ethphy1: ethernet-phy@1 {
-		compatible = "marvell,88E1514", "marvell,88E1510", "ethernet-phy-ieee802.3-c22";
-		reg = <1>;
+		compatible = "broadcom,54616S",  "ethernet-phy-ieee802.3-c22";
+		reg = <2>;
+	};
+	ethphy2: ethernet-phy@2 {
+		compatible = "broadcom,54616S",  "ethernet-phy-ieee802.3-c22";
+		reg = <3>;
+	};
+	ethphy3: ethernet-phy@3 {
+		compatible = "broadcom,54616S",  "ethernet-phy-ieee802.3-c22";
+		reg = <4>;
 	};
 };
 
 &gbe_serdes0 {
 	status = "okay";
 };
+serdes0_lane0: lane@0 {
+	status = "okay";
+};
+serdes0_lane1: lane@1 {
+	status = "okay";
+};
+serdes0_lane2: lane@2 {
+	status = "okay";
+};
+serdes0_lane3: lane@3 {
+	status = "okay";
+};
+&gbe_serdes1 {
+	status = "okay";
+};
+serdes1_lane0: lane@0 {
+	status = "okay";
+};
+serdes1_lane1: lane@1 {
+	status = "okay";
+};
+serdes1_lane2: lane@2 {
+	status = "okay";
+};
+serdes1_lane3: lane@3 {
+	status = "okay";
+};
+
 
 &pcie1_phy {
 	status = "okay";
diff --git a/ti-processor-sdk-linux-rt-k2e-evm-03.03.00.04/board-support/linux-rt-4.4.41+gitAUTOINC+968d071ce9-g968d071ce9/arch/arm/boot/dts/keystone-k2e-netcp.dtsi b/ti-processor-sdk-linux-rt-k2e-evm-03.03.00.04/board-support/linux-rt-4.4.41+gitAUTOINC+968d071ce9-g968d071ce9/arch/arm/boot/dts/keystone-k2e-netcp.dtsi
index 4aba07d..469cf5d 100644
--- a/ti-processor-sdk-linux-rt-k2e-evm-03.03.00.04/board-support/linux-rt-4.4.41+gitAUTOINC+968d071ce9-g968d071ce9/arch/arm/boot/dts/keystone-k2e-netcp.dtsi
+++ b/ti-processor-sdk-linux-rt-k2e-evm-03.03.00.04/board-support/linux-rt-4.4.41+gitAUTOINC+968d071ce9-g968d071ce9/arch/arm/boot/dts/keystone-k2e-netcp.dtsi
@@ -225,7 +225,7 @@ gbe_subsys: subsys@24200000 {
 };
 
 gbe_serdes0: phy@232a000 {
-	status			= "disabled";
+	status			= "ok";
 	compatible		= "ti,keystone-serdes-gbe";
 	reg			= <0x0232a000 0x2000>;
 	link-rate-kbps		= <1250000>;
@@ -257,7 +257,7 @@ gbe_serdes0: phy@232a000 {
 		tx-coeff	= <0 0 0 12 4>; /* c1 c2 cm att vreg */
 	};
 	serdes0_lane2: lane@2 {
-		status		= "disabled";
+		status		= "ok";
 		/*loopback;*/
 		#phy-cells	= <0>;
 		reg		= <2>;
@@ -267,7 +267,7 @@ gbe_serdes0: phy@232a000 {
 		tx-coeff	= <0 0 0 12 4>; /* c1 c2 cm att vreg */
 	};
 	serdes0_lane3: lane@3 {
-		status		= "disabled";
+		status		= "ok";
 		/*loopback;*/
 		#phy-cells	= <0>;
 		reg		= <3>;
@@ -279,7 +279,7 @@ gbe_serdes0: phy@232a000 {
 };
 
 gbe_serdes1: phy@2324000 {
-	status			= "disabled";
+	status			= "ok";
 	compatible		= "ti,keystone-serdes-gbe";
 	reg			= <0x02324000 0x2000>;
 	link-rate-kbps		= <1250000>;
@@ -291,7 +291,7 @@ gbe_serdes1: phy@2324000 {
 	clock-names = "fck";
 
 	serdes1_lane0: lane@0 {
-		status		= "disabled";
+		status		= "ok";
 		/*loopback;*/
 		#phy-cells	= <0>;
 		reg		= <0>;
@@ -301,7 +301,7 @@ gbe_serdes1: phy@2324000 {
 		tx-coeff	= <0 0 0 12 4>; /* c1 c2 cm att vreg */
 	};
 	serdes1_lane1: lane@1 {
-		status		= "disabled";
+		status		= "ok";
 		/*loopback;*/
 		#phy-cells	= <0>;
 		reg		= <1>;
@@ -311,7 +311,7 @@ gbe_serdes1: phy@2324000 {
 		tx-coeff	= <0 0 0 12 4>; /* c1 c2 cm att vreg */
 	};
 	serdes1_lane2: lane@2 {
-		status		= "disabled";
+		status		= "ok";
 		/*loopback;*/
 		#phy-cells	= <0>;
 		reg		= <2>;
@@ -321,7 +321,7 @@ gbe_serdes1: phy@2324000 {
 		tx-coeff	= <0 0 0 12 4>; /* c1 c2 cm att vreg */
 	};
 	serdes1_lane3: lane@3 {
-		status		= "disabled";
+		status		= "ok";
 		/*loopback;*/
 		#phy-cells	= <0>;
 		reg		= <3>;
@@ -348,6 +348,12 @@ netcp: netcp@24000000 {
 
 	ti,navigator-dmas =	<&dma_gbe 0>,
 				<&dma_gbe 8>,
+				<&dma_gbe 16>,
+				<&dma_gbe 24>,
+				<&dma_gbe 32>,
+				<&dma_gbe 40>,
+				<&dma_gbe 48>,
+				<&dma_gbe 56>,
 				<&dma_gbe 0>,
 				<&dma_gbe 22>,
 				<&dma_gbe 23>,
@@ -369,6 +375,12 @@ netcp: netcp@24000000 {
 
 	ti,navigator-dma-names = "netrx0",
 				 "netrx1",
+				 "netrx2",
+				 "netrx3",
+				 "netrx4",
+				 "netrx5",
+				 "netrx6",
+				 "netrx7",
 				 "nettx",
 				 "netrx0-pa",
 				 "netrx1-pa",
@@ -418,39 +430,41 @@ netcp: netcp@24000000 {
 					link-interface	= <1>;
 					phy-handle	= <&ethphy1>;
 				};
-			};
-
-			secondary-slave-ports {
-				port-2 {
-					phys = <&serdes0_lane2>;
-					slave-port = <2>;
-					link-interface	= <2>;
+				gbe2: interface-2 {
+					phys		= <&serdes0_lane2>;
+					slave-port	= <2>;
+					link-interface	= <1>;
+					phy-handle	=<&ethphy2>;
 				};
-				port-3 {
-					phys = <&serdes0_lane3>;
-					slave-port = <3>;
+				gbe3: interface-3 {
+					phy		= <&serdes0_lane3>;
+					slave-port	= <3>;
 					link-interface	= <2>;
 				};
-				port-4 {
-					phys = <&serdes1_lane0>;
-					slave-port = <4>;
+				gbe4: interface-4 {
+					phy		= <&serdes1_lane0>;
+					slave-port	= <4>;
 					link-interface	= <2>;
 				};
-				port-5 {
-					phys = <&serdes1_lane1>;
-					slave-port = <5>;
-					link-interface	= <2>;
+				gbe5: interface-5 {
+					phys		= <&serdes1_lane1>;
+					slave-port	= <5>;
+					link-interface	= <1>;
+					phy-handle	=<&ethphy3>;
 				};
-				port-6 {
-					phys = <&serdes1_lane2>;
-					slave-port = <6>;
+				gbe6: interface-6 {
+					phy		= <&serdes1_lane2>;
+					slave-port	= <6>;
 					link-interface	= <2>;
 				};
-				port-7 {
-					phys = <&serdes1_lane3>;
-					slave-port = <7>;
+				gbe7: interface-7 {
+					phy		= <&serdes1_lane3>;
+					slave-port	= <7>;
 					link-interface	= <2>;
-				};
+				};	
+			};
+
+			secondary-slave-ports {
 			};
 		};
 
@@ -494,6 +508,33 @@ netcp: netcp@24000000 {
 					slave-port	= <1>;
 					rx-channel	= "netrx1-pa";
 				};
+				
+				pa2: interface-2 {
+					slave-port	= <2>;
+					rx-channel	= "netrx2-pa";
+				};
+				pa3: interface-3 {
+					slave-port	= <3>;
+					rx-channel	= "netrx3-pa";
+				};
+				pa4: interface-4 {
+					slave-port	= <4>;
+					rx-channel	= "netrx4-pa";
+				};
+				pa5: interface-5 {
+					slave-port	= <5>;
+					rx-channel	= "netrx5-pa";
+				};
+				pa6: interface-6 {
+					slave-port	= <6>;
+					rx-channel	= "netrx6-pa";
+				};
+				pa7: interface-7 {
+					slave-port	= <7>;
+					rx-channel	= "netrx7-pa";
+				};
+
+
 			};
 
 			/* PA clusters that does packet processing */
@@ -581,7 +622,7 @@ netcp: netcp@24000000 {
 				    64 12 17 17
 				    64 12 17 17
 				    64 12 17 17>;
-			tx-completion-queue = <530>;
+			tx-completion-queue = <536>;
 			efuse-mac = <1>;
 			netcp-gbe = <&gbe0>;
 			netcp-pa2 = <&pa0>;
@@ -600,13 +641,122 @@ netcp: netcp@24000000 {
 				    64 12 17 17
 				    64 12 17 17
 				    64 12 17 17>;
-			tx-completion-queue = <531>;
+			tx-completion-queue = <537>;
 			efuse-mac = <0>;
 			local-mac-address = [02 18 31 7e 3e 00];
 			netcp-gbe = <&gbe1>;
 			netcp-pa2 = <&pa1>;
 			netcp-qos = <&qos1>;
 		};
+		interface-2 {
+			rx-channel = "netrx2";
+			rx-pool = <1024 12>;
+			rx-queue-depth = <128 128 0 0>;
+			rx-buffer-size = <1518 4096 0 0>;
+			rx-queue = <530>;
+			tx-pools = <1024 12 17 17
+				    64 12 17 17
+				    64 12 17 17
+				    64 12 17 17
+				    64 12 17 17
+				    64 12 17 17
+				    64 12 17 17>;
+			tx-completion-queue = <538>;
+			efuse-mac = <1>;
+			netcp-gbe = <&gbe2>;
+			netcp-pa2 = <&pa2>;
+		};
+		interface-3 {
+			rx-channel = "netrx3";
+			rx-pool = <1024 12>;
+			rx-queue-depth = <128 128 0 0>;
+			rx-buffer-size = <1518 4096 0 0>;
+			rx-queue = <531>;
+			tx-pools = <1024 12 17 17
+				    64 12 17 17
+				    64 12 17 17
+				    64 12 17 17
+				    64 12 17 17
+				    64 12 17 17
+				    64 12 17 17>;
+			tx-completion-queue = <539>;
+			efuse-mac = <1>;
+			netcp-gbe = <&gbe3>;
+			netcp-pa2 = <&pa3>;
+		};
+		interface-4 {
+			rx-channel = "netrx4";
+			rx-pool = <1024 12>;
+			rx-queue-depth = <128 128 0 0>;
+			rx-buffer-size = <1518 4096 0 0>;
+			rx-queue = <532>;
+			tx-pools = <1024 12 17 17
+				    64 12 17 17
+				    64 12 17 17
+				    64 12 17 17
+				    64 12 17 17
+				    64 12 17 17
+				    64 12 17 17>;
+			tx-completion-queue = <540>;
+			efuse-mac = <1>;
+			netcp-gbe = <&gbe4>;
+			netcp-pa2 = <&pa4>;
+		};
+		interface-5 {
+			rx-channel = "netrx5";
+			rx-pool = <1024 12>;
+			rx-queue-depth = <128 128 0 0>;
+			rx-buffer-size = <1518 4096 0 0>;
+			rx-queue = <533>;
+			tx-pools = <1024 12 17 17
+				    64 12 17 17
+				    64 12 17 17
+				    64 12 17 17
+				    64 12 17 17
+				    64 12 17 17
+				    64 12 17 17>;
+			tx-completion-queue = <541>;
+			efuse-mac = <1>;
+			netcp-gbe = <&gbe5>;
+			netcp-pa2 = <&pa5>;
+		};
+		interface-6 {
+			rx-channel = "netrx6";
+			rx-pool = <1024 12>;
+			rx-queue-depth = <128 128 0 0>;
+			rx-buffer-size = <1518 4096 0 0>;
+			rx-queue = <534>;
+			tx-pools = <1024 12 17 17
+				    64 12 17 17
+				    64 12 17 17
+				    64 12 17 17
+				    64 12 17 17
+				    64 12 17 17
+				    64 12 17 17>;
+			tx-completion-queue = <542>;
+			efuse-mac = <1>;
+			netcp-gbe = <&gbe6>;
+			netcp-pa2 = <&pa6>;
+		};
+		interface-7 {
+			rx-channel = "netrx7";
+			rx-pool = <1024 12>;
+			rx-queue-depth = <128 128 0 0>;
+			rx-buffer-size = <1518 4096 0 0>;
+			rx-queue = <535>;
+			tx-pools = <1024 12 17 17
+				    64 12 17 17
+				    64 12 17 17
+				    64 12 17 17
+				    64 12 17 17
+				    64 12 17 17
+				    64 12 17 17>;
+			tx-completion-queue = <543>;
+			efuse-mac = <1>;
+			netcp-gbe = <&gbe7>;
+			netcp-pa2 = <&pa7>;
+		};
+		
 	};
 };
 
@@ -739,8 +889,8 @@ netcpx: netcp@2f00000 {
 			tx-pool = <1024 12>; /* num_desc region-id */
 			rx-queue-depth = <1024 1024 0 0>;
 			rx-buffer-size = <1536 4096 0 0>;
-			rx-queue = <532>;
-			tx-completion-queue = <534>;
+			rx-queue = <544>;
+			tx-completion-queue = <546>;
 			efuse-mac = <0>;
 			netcp-xgbe = <&xgbe0>;
 
@@ -751,8 +901,8 @@ netcpx: netcp@2f00000 {
 			tx-pool = <1024 12>; /* num_desc region-id */
 			rx-queue-depth = <1024 1024 0 0>;
 			rx-buffer-size = <1536 4096 0 0>;
-			rx-queue = <533>;
-			tx-completion-queue = <535>;
+			rx-queue = <545>;
+			tx-completion-queue = <547>;
 			efuse-mac = <0>;
 			netcp-xgbe = <&xgbe1>;
 		};
@@ -791,12 +941,12 @@ sa_subsys: subsys@24080000 {
 
 		ti,rx-channel = "crypto-rx";
 		ti,rx-queue-depth = <256 64 0 0>;
-		ti,rx-compl-queue = <536>;
+		ti,rx-compl-queue = <548>;
 		ti,rx-pool	= <512 12>;
 
 		ti,tx-channel = "crypto-tx";
 		ti,tx-queue-depth = <256>;
-		ti,tx-completion-queue = <537>;
+		ti,tx-completion-queue = <549>;
 		ti,tx-pool = <512 12>;
 		ti,tx-submit-queue = <914>;
 