diff --git a/examples/drivers/mcan/mcan_loopback_polling/am62px-sk/mcu-r5fss0-0_nortos/example.syscfg b/examples/drivers/mcan/mcan_loopback_polling/am62px-sk/mcu-r5fss0-0_nortos/example.syscfg
index e09bffd7..9604b99a 100644
--- a/examples/drivers/mcan/mcan_loopback_polling/am62px-sk/mcu-r5fss0-0_nortos/example.syscfg
+++ b/examples/drivers/mcan/mcan_loopback_polling/am62px-sk/mcu-r5fss0-0_nortos/example.syscfg
@@ -1,15 +1,14 @@
 /**
  * These arguments were used when this file was generated. They will be automatically applied on subsequent loads
  * via the GUI or CLI. Run CLI with '--help' for additional information on how to override these arguments.
- * @cliArgs --device "AM62Px" --package "AMH" --part "Default" --context "mcu-r5fss0-0" --product "MCU_PLUS_SDK_AM62Px@11.00.00"
- * @versions {"tool":"1.16.1+2960"}
+ * @cliArgs --device "AM62Px" --part "Default" --package "AMH" --context "mcu-r5fss0-0" --product "MCU_PLUS_SDK_AM62Px@11.00.00"
+ * @v2CliArgs --device "AM62P" --package "FCBGA (AMH)" --variant "AM62P54-M" --context "mcu-r5fss0-0" --product "MCU_PLUS_SDK_AM62Px@11.00.00"
+ * @versions {"tool":"1.23.0+3981"}
  */
 
 /**
  * Import the modules used in this configuration.
  */
-const mcan       = scripting.addModule("/drivers/mcan/mcan", {}, false);
-const mcan1      = mcan.addInstance();
 const debug_log  = scripting.addModule("/kernel/dpl/debug_log");
 const mpu_armv7  = scripting.addModule("/kernel/dpl/mpu_armv7", {}, false);
 const mpu_armv71 = mpu_armv7.addInstance();
@@ -21,8 +20,6 @@ const mpu_armv75 = mpu_armv7.addInstance();
 /**
  * Write custom configuration values to the imported modules.
  */
-mcan1.$name = "CONFIG_MCAN0";
-
 debug_log.enableUartLog = true;
 debug_log.uartLog.$name = "CONFIG_UART0";
 
@@ -55,9 +52,6 @@ mpu_armv75.$name    = "CONFIG_MPU_DDR";
  * version of the tool will not impact the pinmux you originally saw.  These lines can be completely deleted in order to
  * re-solve from scratch.
  */
-mcan1.MCU_MCAN.$suggestSolution                 = "MCU_MCAN0";
-mcan1.MCU_MCAN.RX.$suggestSolution              = "MCU_MCAN0_RX";
-mcan1.MCU_MCAN.TX.$suggestSolution              = "MCU_MCAN0_TX";
 debug_log.uartLog.MCU_UART.$suggestSolution     = "MCU_USART0";
 debug_log.uartLog.MCU_UART.RXD.$suggestSolution = "MCU_UART0_RXD";
 debug_log.uartLog.MCU_UART.TXD.$suggestSolution = "MCU_UART0_TXD";
diff --git a/examples/drivers/mcan/mcan_loopback_polling/am62px-sk/mcu-r5fss0-0_nortos/main.c b/examples/drivers/mcan/mcan_loopback_polling/am62px-sk/mcu-r5fss0-0_nortos/main.c
index 468d0d64..ff45665c 100644
--- a/examples/drivers/mcan/mcan_loopback_polling/am62px-sk/mcu-r5fss0-0_nortos/main.c
+++ b/examples/drivers/mcan/mcan_loopback_polling/am62px-sk/mcu-r5fss0-0_nortos/main.c
@@ -38,13 +38,40 @@
 
 void mcan_loopback_polling_main(void *args);
 
+#include <drivers/pinmux.h>
+
+static Pinmux_PerCfg_t gPinMuxMainCfg[] = {
+    {
+        PIN_MCAN0_RX,
+        ( PIN_MODE(0) | PIN_INPUT_ENABLE | PIN_PULL_DISABLE )
+    },
+            /* MCAN0_TX -> MCAN0_TX (B17) */
+    {
+        PIN_MCAN0_TX,
+        ( PIN_MODE(0) | PIN_PULL_DISABLE )
+    },
+    {PINMUX_END, PINMUX_END}
+};
+
 int main()
 {
+
+    Pinmux_config(gPinMuxMainCfg, PINMUX_DOMAIN_ID_MAIN); // Configure PinMux
+
     System_init();
     Board_init();
 
     int32_t status = SystemP_SUCCESS;
 
+    status = SOC_moduleClockEnable(TISCI_DEV_MCAN0, 1);
+    DebugP_assertNoLog(status == SystemP_SUCCESS);
+    status = SOC_moduleSetClockFrequency(
+                    TISCI_DEV_MCAN0,
+                    TISCI_DEV_MCAN0_MCANSS_CCLK_CLK,
+                    80000000 
+                    );
+    DebugP_assertNoLog(status == SystemP_SUCCESS);
+
     /* Open drivers */
     Drivers_open();
     /* Open flash and board drivers */
diff --git a/examples/drivers/mcan/mcan_loopback_polling/mcan_loopback_polling.c b/examples/drivers/mcan/mcan_loopback_polling/mcan_loopback_polling.c
index 4825da08..13bc1841 100644
--- a/examples/drivers/mcan/mcan_loopback_polling/mcan_loopback_polling.c
+++ b/examples/drivers/mcan/mcan_loopback_polling/mcan_loopback_polling.c
@@ -54,6 +54,27 @@
 #include "ti_drivers_open_close.h"
 #include "ti_board_open_close.h"
 
+
+#include <drivers/mcan.h>
+
+/* MCAN Instance Macros */
+#define CONFIG_MCAN0_BASE_ADDR (CSL_MCAN0_MSGMEM_RAM_BASE)
+#define CONFIG_MCAN0_INTR (187U)
+#define CONFIG_MCAN_NUM_INSTANCES (1U)
+
+MCAN_BitTimingParams gMcanBitTimingDefaultParams =
+{
+    .nomRatePrescalar   = 0x7U,
+    .nomTimeSeg1        = 0x5U,
+    .nomTimeSeg2        = 0x2U,
+    .nomSynchJumpWidth  = 0x0U,
+    .dataRatePrescalar  = 0x1U,
+    .dataTimeSeg1       = 0x3U,
+    .dataTimeSeg2       = 0x2U,
+    .dataSynchJumpWidth = 0x0U,
+};
+
+
 #define APP_MCAN_BASE_ADDR                       (CONFIG_MCAN0_BASE_ADDR)
 #define APP_MCAN_INTR_NUM                        (CONFIG_MCAN0_INTR)
 #define APP_MCAN_MSG_LOOP_COUNT                  (10U)