diff --git a/packages/ti/drv/dss/examples/dss_m2m_test/dss_m2m_test.c b/packages/ti/drv/dss/examples/dss_m2m_test/dss_m2m_test.c
index 4e899ae..5b6a0ae 100755
--- a/packages/ti/drv/dss/examples/dss_m2m_test/dss_m2m_test.c
+++ b/packages/ti/drv/dss/examples/dss_m2m_test/dss_m2m_test.c
@@ -185,10 +185,20 @@ static int32_t App_initParams(M2MApp_AppObj *appObj)
         /* Initialize Display pipeline parameters */
         for (pipeIdx = 0U ; pipeIdx < APP_DSS_M2M_DSS_PIPE_NUM ; pipeIdx++)
         {
-            instObj->createParams.pipeId[pipeIdx] = APP_DSS_M2M_DSS_PIPE_ID;
-            instObj->pipeCfg[pipeIdx].pipeId      = APP_DSS_M2M_DSS_PIPE_ID;
-            instObj->mFlagCfg[pipeIdx].pipeId     = APP_DSS_M2M_DSS_PIPE_ID;
-            instObj->cscCfg[pipeIdx].pipeId       = APP_DSS_M2M_DSS_PIPE_ID;
+            if (0 == pipeIdx)
+            {
+                instObj->createParams.pipeId[pipeIdx] = APP_DSS_M2M_DSS_PIPE_ID;
+                instObj->pipeCfg[pipeIdx].pipeId      = APP_DSS_M2M_DSS_PIPE_ID;
+                instObj->mFlagCfg[pipeIdx].pipeId     = APP_DSS_M2M_DSS_PIPE_ID;
+                instObj->cscCfg[pipeIdx].pipeId       = APP_DSS_M2M_DSS_PIPE_ID;
+            }
+            else
+            {
+                instObj->createParams.pipeId[pipeIdx] = CSL_DSS_VID_PIPE_ID_VID2;
+                instObj->pipeCfg[pipeIdx].pipeId      = CSL_DSS_VID_PIPE_ID_VID2;
+                instObj->mFlagCfg[pipeIdx].pipeId     = CSL_DSS_VID_PIPE_ID_VID2;
+                instObj->cscCfg[pipeIdx].pipeId       = CSL_DSS_VID_PIPE_ID_VID2;
+            }
             dispParams = &instObj->pipeCfg[pipeIdx].cfgParams;
             Dss_dispParamsInit(dispParams);
             dispParams->pipeCfg.pipeType = CSL_DSS_VID_PIPE_TYPE_VID;
@@ -199,13 +209,24 @@ static int32_t App_initParams(M2MApp_AppObj *appObj)
                 dispParams->pipeCfg.inFmt.pitch[planeIdx] = APP_DSS_M2M_IN_FRAME_PITCH;
             }
             dispParams->pipeCfg.inFmt.dataFormat  = APP_DSS_M2M_IN_FRAME_FORMAT;
-            dispParams->pipeCfg.outWidth          = APP_DSS_M2M_IN_FRAME_WIDTH;
-            dispParams->pipeCfg.outHeight         = APP_DSS_M2M_IN_FRAME_HEIGHT;
-            dispParams->pipeCfg.scEnable          = FALSE;
+            if (0 == pipeIdx)
+            {
+                dispParams->pipeCfg.outWidth          = 960;//APP_DSS_M2M_IN_FRAME_WIDTH;
+                dispParams->pipeCfg.outHeight         = 540;//APP_DSS_M2M_IN_FRAME_HEIGHT;
+                dispParams->layerPos.startX           = 0U;
+                dispParams->layerPos.startY           = 0U;
+            }
+            else
+            {
+                dispParams->pipeCfg.outWidth          = 640;//APP_DSS_M2M_IN_FRAME_WIDTH;
+                dispParams->pipeCfg.outHeight         = 360;//APP_DSS_M2M_IN_FRAME_HEIGHT;
+
+                dispParams->layerPos.startX           = 960;
+                dispParams->layerPos.startY           = 540;
+            }
+            dispParams->pipeCfg.scEnable          = TRUE;
             dispParams->alphaCfg.globalAlpha      = 0xFFU;
             dispParams->alphaCfg.preMultiplyAlpha = FALSE;
-            dispParams->layerPos.startX           = 0U;
-            dispParams->layerPos.startY           = 0U;
 
             Dss_dispPipeMflagParamsInit(&instObj->mFlagCfg[pipeIdx].mFlagCfg);
 
@@ -248,7 +269,7 @@ static int32_t App_initParams(M2MApp_AppObj *appObj)
         ovrParams->colorbarEnable = FALSE;
         ovrParams->overlayCfg.colorKeyEnable = FALSE;
         ovrParams->overlayCfg.colorKeySel = CSL_DSS_OVERLAY_TRANS_COLOR_DEST;
-        ovrParams->overlayCfg.backGroundColor = 0xc8c800U;
+        ovrParams->overlayCfg.backGroundColor = 0x0;
 
         layerParams = &instObj->layerCfg;
         Dss_dctrlOverlayLayerParamsInit(layerParams);
@@ -258,8 +279,12 @@ static int32_t App_initParams(M2MApp_AppObj *appObj)
         {
             layerParams->pipeLayerNum[layerIdx] = CSL_DSS_OVERLAY_LAYER_INVALID;
         }
-        layerParams->pipeLayerNum[instObj->createParams.pipeId[0U]] =
+        for (pipeIdx = 0U ; pipeIdx < APP_DSS_M2M_DSS_PIPE_NUM ; pipeIdx++)
+        {
+            layerParams->pipeLayerNum[instObj->createParams.pipeId[pipeIdx]] =
                                                     CSL_DSS_OVERLAY_LAYER_NUM_0;
+        }
+
         if(APP_DSS_M2M_DSS_PIPE_NUM > 1U)
         {
             for(layerIdx = 1U ; layerIdx < APP_DSS_M2M_DSS_PIPE_NUM ; layerIdx++)
@@ -653,7 +678,7 @@ static int32_t App_allocAndQueueFrames(M2MApp_InstParams *instObj)
     frm = (Fvid2_Frame *) &instObj->outFrames[0U];
     /* init Fvid2_Frame to 0's  */
     frm->addr[0U] = (uint64_t)&(gOutFrms[(instObj->instIdx * APP_DSS_M2M_CH_NUM)][0U]);
-    frm->addr[1U] = (uint64_t)&(gOutUVComp[(instObj->instIdx * APP_DSS_M2M_CH_NUM)][0U]);
+    frm->addr[1U] = frm->addr[0U] + APP_DSS_M2M_OUT_FRAME_PITCH * APP_DSS_M2M_OUT_FRAME_HEIGHT;
     outFrmList.frames[0U] = frm;
     outFrmList.numFrames = 1U;
     retVal = Fvid2_processRequest(instObj->drvHandle,
diff --git a/packages/ti/drv/dss/examples/dss_m2m_test/dss_m2m_test_cfg.h b/packages/ti/drv/dss/examples/dss_m2m_test/dss_m2m_test_cfg.h
index 048f337..5eddf6e 100755
--- a/packages/ti/drv/dss/examples/dss_m2m_test/dss_m2m_test_cfg.h
+++ b/packages/ti/drv/dss/examples/dss_m2m_test/dss_m2m_test_cfg.h
@@ -76,7 +76,7 @@ extern "C" {
 #define APP_DSS_M2M_CH_NUM                           ((uint32_t)1U)
 
 /**< Number of display pipelines to use */
-#define APP_DSS_M2M_DSS_PIPE_NUM                     ((uint32_t)1U)
+#define APP_DSS_M2M_DSS_PIPE_NUM                     ((uint32_t)2U)
 
 /**< ID of display pipeline to use */
 #define APP_DSS_M2M_DSS_PIPE_ID                      (CSL_DSS_VID_PIPE_ID_VID1)
diff --git a/packages/ti/drv/dss/soc/V1/dss_soc.h b/packages/ti/drv/dss/soc/V1/dss_soc.h
index c0b73ea..d25b159 100755
--- a/packages/ti/drv/dss/soc/V1/dss_soc.h
+++ b/packages/ti/drv/dss/soc/V1/dss_soc.h
@@ -205,7 +205,7 @@ typedef void (*Dss_DctrlDpHpdCbFxn)(uint32_t hpdState, void *appData);
 #define DSSM2M_NUM_WB_PIPELINE                       (CSL_DSS_WB_PIPE_ID_MAX)
 
 /** \brief DSS pipe-lines number available in the SoC for blending in M2M mode */
-#define DSSM2M_NUM_PIPELINE_TO_USE_IN_M2M_MODE       (1U)
+#define DSSM2M_NUM_PIPELINE_TO_USE_IN_M2M_MODE       (2U)
 
 /** \brief DSS M2M DRV Virtual Context: Number of virtual contexts per DSS M2M pipeline */
 #define DSSM2M_NUM_VIRTUAL_CONTEXT                   (8U)